      SUBROUTINE rotunits( VROT , X )
      
      IMPLICIT NONE
      CHARACTER VROT*4      
      DOUBLE PRECISION X
      SAVE
     
c      CONVERT UNITS TO amu*Ang^2
c      For qro and rot types [NOT hindered rotorS]:
c          VROT = 'AMUA' for moment of inertia in units of amu*Ang^2
c       or      = 'GMCM' for moment of inertia units of gram*cm^2
c       or      = 'CM-1' for rotational constant in units of cm^-1
c       or      = 'MHZ' for rotational constant in units of MHz
c       or      = 'GHZ' for rotational constant in units of GHz
c         
      IF (     VROT .EQ. 'AMUA'
     &    .OR. VROT .EQ. 'amua' 
     &   ) THEN
        RETURN
      ELSEIF ( VROT .EQ. 'GMCM'
     &    .OR. VROT .EQ. 'gmcm'
     &    .OR. VROT .EQ. 'GmCm'
     & ) THEN
        X = X / 1.660538782d-040
        RETURN
      ELSEIF ( VROT .EQ. 'CM-1'
     &    .OR. VROT .EQ. 'cm-1'
     &  ) THEN
        X = 16.85763D+00 / X
        RETURN
      ELSEIF ( VROT .EQ. 'MHZ'
     &    .OR. VROT .EQ. 'MHz' 
     &    .OR. VROT .EQ. 'mhz'
     &    .OR. VROT .EQ. 'Mhz'
     & ) THEN
        X = 5.05379D+005 / X
      ELSEIF ( VROT .EQ. 'GHZ'
     &    .OR. VROT .EQ. 'GHz' 
     &    .OR. VROT .EQ. 'ghz'
     &    .OR. VROT .EQ. 'Ghz'
     & ) THEN
        X = 5.05379D+002 / X
        RETURN
      ELSE
        write (*,*) 'FATAL: units (VROT) for rotations not recongized'
        STOP
      ENDIF

      END
      
      
